/* gtk ochre die roller - a GTK application to roll dice
 * 
 * Written by Ken Witherow <phantoml@frontiernet.net>
 *
 * This software is licensed under the GNU GPL. Please see
 * the COPYING file
 * No warranty. Use at your own risk.
 */

#include <gtk/gtk.h>
#include <stdio.h>

#include <ochregtk.h>
#include <dice.h>

GtkWidget *resultbox;
GtkWidget *numdice;
GtkWidget *numdiceadj;
GtkWidget *dicemod;
GtkWidget *dicemodadj;

void aboutpop( void )
{
    GtkWidget *gtk_dialog_new( void );
    GtkWidget *aboutwin;
    GtkWidget *aboutdone;
    GtkWidget *aboutlabel;
    char *aboutbox = malloc( 100 );

    aboutwin = gtk_dialog_new();
    aboutdone = gtk_button_new_with_label( "Done" );
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(aboutwin)->action_area), aboutdone, TRUE, TRUE, 0);
    sprintf( aboutbox, "Gtk Ochre Dice Roller version %s", VERSION );
    aboutlabel = gtk_label_new( aboutbox );
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(aboutwin)->vbox), aboutlabel, TRUE, TRUE, 0);
    aboutlabel = gtk_label_new( "Copyright 1999, Ken Witherow. No warranty. Use at your own risk. \n\n" );
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(aboutwin)->vbox), aboutlabel, TRUE, TRUE, 0);
    aboutlabel = gtk_label_new( "This program rolls a variety of dice with options to roll multiples with modifiers\n\n" );
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(aboutwin)->vbox), aboutlabel, TRUE, TRUE, 0);
    aboutlabel = gtk_label_new( " New versions of OCHRE can be found at http://www.frontiernet.net/~phantoml/adnd/ochre.html " );
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(aboutwin)->vbox), aboutlabel, TRUE, TRUE, 0);

    gtk_signal_connect(GTK_OBJECT( aboutdone ), "clicked", GTK_SIGNAL_FUNC( closepopup ), aboutwin);
    gtk_widget_show_all( aboutwin );
}
/* Roll the dice. output to resultbox */
void roll( GtkWidget *widget, gint size )
{
	char res[6];
    int counter = 0;
    int total = 0;
	gint cycles;
	cycles = gtk_spin_button_get_value_as_int( numdice );
    for (counter; counter < cycles; counter++)
        total += die( size );
    total += gtk_spin_button_get_value_as_int( dicemod );
	sprintf( res, "%d", total );
	gtk_entry_set_text( GTK_ENTRY( resultbox ), res );
} 

int main( int argc, char *argv[] )
{
	GtkWidget *window;
	GtkWidget *button2;
	GtkWidget *button4;
	GtkWidget *button6;
	GtkWidget *button8;
	GtkWidget *button10;
	GtkWidget *button12;
	GtkWidget *button20;
	GtkWidget *button100;
	GtkWidget *buttonquit;
	GtkWidget *buttonabout;
	GtkWidget *numlabel;
    GtkWidget *adjlabel;
    GtkWidget *table;
    GtkWidget *vbox;
	GtkWidget *vbox2;
		
	gtk_init (&argc, &argv);

    /* create a new window */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW( window ), "GtkOchreDiceRoller");

    table = gtk_table_new( 4, 4, TRUE );
	
    resultbox = gtk_entry_new_with_max_length( 6 );
    gtk_entry_set_editable(GTK_ENTRY( resultbox ), 0);

	gtk_container_add(GTK_CONTAINER( window ), table );
      
    /* Sets the border width of the window. */
    gtk_container_set_border_width(GTK_CONTAINER(window), 10);

    button2 = gtk_button_new_with_label( "Roll d2" );
    button4 = gtk_button_new_with_label( "Roll d4" );
    button6 = gtk_button_new_with_label( "Roll d6" );
    button8 = gtk_button_new_with_label( "Roll d8" );
    button10 = gtk_button_new_with_label( "Roll d10" );
    button12 = gtk_button_new_with_label( "Roll d12" );
    button20 = gtk_button_new_with_label( "Roll d20" );
    button100 = gtk_button_new_with_label( "Roll d100" );
    buttonquit = gtk_button_new_with_label( "Quit" );  
    buttonabout = gtk_button_new_with_label( "About" );
    numlabel = gtk_label_new( "Num dice" );
    adjlabel = gtk_label_new( "Modifier" );
    
    numdiceadj = gtk_adjustment_new( 1, 1, 100, 1, 5, 1 );
    numdice = gtk_spin_button_new( numdiceadj, 1.0, 0 );
    dicemodadj = gtk_adjustment_new( 0, -10, 10, 1, 5, 1 );
    dicemod = gtk_spin_button_new( dicemodadj, 1.0, 0 );
        
	/* connect the signal handlers */ 
    gtk_signal_connect(GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC ( destroy ), NULL);
    gtk_signal_connect(GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC ( delete_event ), NULL);
	gtk_signal_connect(GTK_OBJECT( buttonquit ), "clicked", GTK_SIGNAL_FUNC( destroy ), NULL);
	gtk_signal_connect(GTK_OBJECT( button2 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 2);
	gtk_signal_connect(GTK_OBJECT( button4 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 4);
	gtk_signal_connect(GTK_OBJECT( button6 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 6);
	gtk_signal_connect(GTK_OBJECT( button8 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 8);
	gtk_signal_connect(GTK_OBJECT( button10 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 10);
	gtk_signal_connect(GTK_OBJECT( button12 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 12);
	gtk_signal_connect(GTK_OBJECT( button20 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 20);
	gtk_signal_connect(GTK_OBJECT( button100 ), "clicked", GTK_SIGNAL_FUNC( roll ), (gint *) 100);
    gtk_signal_connect(GTK_OBJECT( buttonabout ), "clicked", GTK_SIGNAL_FUNC( aboutpop ), buttonabout );
    
    vbox = gtk_vbox_new( TRUE, 0 );
    gtk_box_pack_start(GTK_BOX(vbox), numlabel, FALSE, TRUE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), numdice, FALSE, TRUE, 5);

    vbox2 = gtk_vbox_new( TRUE, 0 );
    gtk_box_pack_start(GTK_BOX(vbox2), adjlabel, FALSE, TRUE, 5);
    gtk_box_pack_start(GTK_BOX(vbox2), dicemod, FALSE, TRUE, 5);

    /* put the buttons in the table */
	gtk_table_attach_defaults(GTK_TABLE( table ), button2, 0, 1, 0, 1);
    gtk_table_attach_defaults(GTK_TABLE( table ), button4, 1, 2, 0, 1);
    gtk_table_attach_defaults(GTK_TABLE( table ), button6, 2, 3, 0, 1);
    gtk_table_attach_defaults(GTK_TABLE( table ), button8, 3, 4, 0, 1);
    gtk_table_attach_defaults(GTK_TABLE( table ), button10, 0, 1, 1, 2);
    gtk_table_attach_defaults(GTK_TABLE( table ), button12, 1, 2, 1, 2);
    gtk_table_attach_defaults(GTK_TABLE( table ), button20, 2, 3, 1, 2);
	gtk_table_attach_defaults(GTK_TABLE( table ), button100, 3, 4, 1, 2);
    gtk_table_attach_defaults(GTK_TABLE( table ), vbox, 0, 1, 2, 4 );
    gtk_table_attach_defaults(GTK_TABLE( table ), vbox2, 3, 4, 2, 4 );
    gtk_table_attach_defaults(GTK_TABLE( table ), resultbox, 1, 3, 2, 3);
    gtk_table_attach_defaults(GTK_TABLE( table ), buttonquit, 1, 2, 3, 4);
    gtk_table_attach_defaults(GTK_TABLE( table ), buttonabout, 2, 3, 3, 4);

    gtk_widget_show_all( window );	

    gtk_main ();
           
    return(0);
 }
